#ifndef _INCLUDE_H_
#define _INCLUDE_H_

#include <stdio.h>
#include <string.h>

// Global variables
volatile int command;
bool halt=false;
char string[257];
char string1[257];
char source[257];
char destination[257];

char input[800];
char comm[257];
char arg1[257];


// Function declarations
void CommandInterface(void);
void CommandInterpreter(int command);


void ListDirectory(void);
void ChangeDirectory(char* string);
void TraverseUp(void);
char* GetCurrentWorkingDirectory(void);
void Search(char* string);
void CreateDirectory(char* string);
void CopyFile(char* source,char* destination);
void ReadFile(char* source, char* destination);
void Erase(char* string);
//void EraseFile(char* string);
void GotoRoot();

void InitPLL_SDRAM();
#endif
