#include "string.h"
#include "mmc_access.h"
#include "FAT16.h"
#include "stdio.h"
#include "ctype.h"

int current_dir=0;
int flag_DIRdelete=0;
PATH_t p1;


void GetFATInfo()
{
   int i=0;
   
   dummy=(BYTE*)malloc(5);
   current_fs=(FS_t*)malloc(sizeof(FS_t));
   fnFAT16_init(current_fs,0);
   strcpy(p1.path[0],"ROOT");
   p1.level=0;      
}





int copyFILE(BYTE* source,BYTE* destination)
{
    
    int success=1;
    if(destination[0]=='\0')
    {
        printf("\n\Please enter a valid name for destination file\n\n");
    	return 0;
    }
    
    int ww=0;
    while(destination[ww]!='.'&&destination[ww]!='\0')
        		ww++;
        		
    
    if(destination[ww]=='\0')
    {
        printf("\nPlease type an extension for the destination file\n");
        return 0;
    }
        
        
    
    FILELIST_t* create_list= fnListDirectory(current_dir);
    BYTE* buff;
    buff=(BYTE*)(malloc(1024));
    DWORD size=0;
    
    
    
    
    int i=0;
    char temp[257];
    char temp1[257];
    strcpy(temp,destination);
    int ti=0;  
    char tt;
    while(temp[ti]!='\0')
    {
        tt=tolower(temp[ti]);
        temp[ti]=tt;
        ti++;
    }
   
    for(i=0;i<create_list->num;i++)
    {
        if(current_dir!=0&&i==0)
        continue;
        
        strcpy(temp1,create_list->list[i]->filename);
        ti=0;
        while(temp1[ti]!='\0')
    	{
        	tt=tolower(temp1[ti]);
        	temp1[ti]=tt;
        	ti++;
   		 }
        
        if(!strcmp(temp,temp1))
        
        break;
    }
   
   if(i!=create_list->num&&(create_list->list[i]->type!=FILE_ATTR_DIRECTORY))
   {
       printf("\nFile already exists\n\n",destination);
       success=0;
   }    
   
   else
   { 
		FILE_t* fp;
	
   		FILE* handle;
  		handle=fopen(source,"rb");
   		if(handle==NULL)
   		{
   		    printf("\nFile mentioned could not be found on the local disk\n\n");
   		    success=0;
   		}
   		
   		else
   		{
   		    
   		    
   		    printf("\nPlease wait! Transfer is in progress..");
           
   		    int k_bytes=1;
   		    int ch1=fgetc(handle);
   		    char ch;
   		    ch=ch1;
   		    
   
   		    fp=fnCreateFile(current_dir,destination);
   		    
   		    int k_count=0;
			
   		    i=0;
   		    while(!feof(handle))
   		    {
   		       
   		        buff[i++]=ch&0x000000FF;

   		        buff[i++]=(ch>>8)&0x000000FF;
   		        buff[i++]=(ch>>16)&0x000000FF;
   		        buff[i++]=(ch>>24)&0x000000FF;

   		        ch1;
   		        ch1=fgetc(handle);
   		        ch=(char)(ch1);
   		        
   		        
   		        
   		        if(i==1024)
   		        {
   		            fnWriteFile(buff,1,1024,fp);
   		            
   		            if(k_bytes%10==0)
   		                printf(".");
   		            
   		            k_bytes++;
   		            i=0;
   		        }
   		          	
   		    }
   		    
   		    if(i!=0)
   		    {
   		      	 fnWriteFile(buff,1,i,fp);
   		    }
   		    
			free(fp);
			free(buff);
   		}
   	}
   	
   int xx=0;
   for(xx=0;xx<create_list->num;xx++)
   free(create_list->list[xx]);
   free(create_list->list);
   free(create_list);
   
   return success;
}

int createDIR(BYTE* string)
{
	
    if(string[0]=='\0')
    {
        printf("\nPlease enter a valid name\n");
        return 0;
    }
   
    FILELIST_t* create_list= fnListDirectory(current_dir);
    
    int success=1;
    int i=0;
    char temp[257];
    char temp1[257];
    strcpy(temp,string);
    char tt;
  	int ti=0;  
    while(temp[ti]!='\0')
    {
        tt=tolower(temp[ti]);
        temp[ti]=tt;
        ti++;
    }

    for(i=0;i<create_list->num;i++)
    {
        if(current_dir!=0&&i==0)
        continue;
        
        strcpy(temp1,create_list->list[i]->filename);
        
        ti=0;
     	while(temp1[ti]!='\0')
    	{
        	tt=tolower(temp1[ti]);
        	temp1[ti]=tt;
        	ti++;
    	}   
        
        if(!strcmp(temp,temp1))
        
        break;
    }
    
    
   
   if(i!=create_list->num&&create_list->list[i]->type&FILE_ATTR_DIRECTORY)
   {
       printf("\nDirectory already exists\n\n",string);
       success=0;
   }    
   
   else
   { 
		fnCreateDir(current_dir,string);
		
   }
   
   int xx=0;
   for(xx=0;xx<create_list->num;xx++)
   free(create_list->list[xx]);
   free(create_list->list);
   free(create_list);
   
   return success;
}

int readFILE(BYTE* source, BYTE* destination)
{
   FILELIST_t* readlist;
   readlist=fnListDirectory(current_dir);
   int success=1;
   int i=0;
   char temp[257];
   char temp1[257];
    
   strcpy(temp,source);

   
   for(i=0;i<readlist->num;i++)
   {
        if(current_dir!=0&&(i==0||i==1))
        continue;
        
        strcpy(temp1,readlist->list[i]->filename);
        
        if(!strcmp(temp,temp1))
        
        break;        
   } 

   if(i==readlist->num||(i!=readlist->num&&readlist->list[i]->type&FILE_ATTR_DIRECTORY))
   {
       printf("\nFile \"%s\" does not exist\n", source);
       success=0;
   }
   
   else
   {
        
	   BYTE* buffer;
	   DWORD size=readlist->list[i]->filesize;
   	   FILE_t* fp=readlist->list[i];
	   buffer=(BYTE*)(malloc(1000));
	   BYTE* buffer1;
	   buffer1=(BYTE*)(malloc(250));
	 
	   FILE* handle=fopen(destination, "wb");
   
	   if(handle==NULL)
	   {
	       printf("\nFile could not be created on local disk\n\n");
	       success=0;
	   }
       else
       {	
		   
           printf("\nPlease wait! Transfer is in progress..");
           
           DWORD kilo_count=size/1000;
	   	   DWORD rest=size%1000;
	   	   int rest1;
	   	   rest1=rest%4;
	   	   rest=(rest/4);
	   
   	 
	   	   int k_count=0;
   	   

		   for(k_count=0;k_count<kilo_count;k_count++)
		   {
	        
	   	   		fnReadFile(buffer, 1, 1000,fp);
   	   		
	   	   		for(i=0;i<250;i++)
	   	   		{
	   	   		    DWORD temp=0;
				    int ii=i*4;
	   	   		    temp=temp|(buffer[ii]);
	   	   		    temp=temp|(buffer[ii+1]<<8);
	   	   		    temp=temp|(buffer[ii+2]<<16);
	   	   		    temp=temp|(buffer[ii+3]<<24);
   	   		    
	   	   		    buffer1[i]=temp;
   	   		     	   	   		}
   	   		    
	   	   		fwrite(buffer1, 1, 250, handle);
	   	   		if(k_count%10==0)
	   	   		{
	   	   			printf(".");
	   	   		}
   	   		
		   }
	   
		   fnReadFile(buffer, 1, (rest*4+rest1),fp);
		   for(i=0;i<rest;i++)
	   	   {
	   	       DWORD temp=0;
		       int ii=i*4;
	   	       temp=temp|(buffer[ii]);
	   	       temp=temp|(buffer[ii+1]<<8);
	   	       temp=temp|(buffer[ii+2]<<16);
	   	       temp=temp|(buffer[ii+3]<<24);
	   	       buffer1[i]=temp;
	   	  	}
	     	
   	  	
		    fwrite(buffer1, 1, rest, handle);
	         
	      
		   fclose(handle);
		   free(buffer);
       }
   }
   
    int xx=0;
	for(xx=0;xx<readlist->num;xx++)
	free(readlist->list[xx]);
	free(readlist->list);
	free(readlist);
	
	return success;
}
           
void erase_FILE_DIR(BYTE* string)
{
    if(string[0]=='\0')
    {
        printf("\nPlease enter a valid name\n");
        return;
    }
	FILELIST_t* delete_list= fnListDirectory(current_dir);    
	int i=0;
    char temp[257];
    char temp1[257];
    
    strcpy(temp,string);

    for(i=0;i<delete_list->num;i++)
    {
        if(current_dir!=0&&i==0)
        continue;
        
        strcpy(temp1,delete_list->list[i]->filename);
        
        if(!strcmp(temp,temp1))
        
        break;
    } 
    
    if(i==delete_list->num)
    {
        printf("\nFile/Directory \"%s\" does not exist\n\n",string);
        
    }
    
    else
    {
        
	    if(i!=delete_list->num&&delete_list->list[i]->type&FILE_ATTR_DIRECTORY)
	    {
        
	    	WORD temp =delete_list->list[i]->startcluster;
	    	eraseDIR_recursive(&temp);
	    }
	    
	    erase(delete_list->list[i]);
	    printf("\n\"%s\"  Deleted\n\n",string);
    }
    
	for(i=0;i<delete_list->num;i++)
	free(delete_list->list[i]);
	free(delete_list->list);
	free(delete_list);
}

void eraseDIR_recursive(WORD* stcluster)
{
    
    FILELIST_t* delete_list= fnListDirectory(*stcluster);
	int i=0;
    for(i=0;i<delete_list->num;i++)
    {
    
        if(delete_list->list[i]->type&FILE_ATTR_DIRECTORY)
        {
           	if((strcmp(delete_list->list[i]->filename,".")==0)||(strcmp(delete_list->list[i]->filename,"..")==0))
			{
				fnDeleteFileLabel(delete_list->list[i]);
				continue;
			}
			else
			
        		eraseDIR_recursive(&(delete_list->list[i]->startcluster));
        }
        
             
        
        fnFreeFile(delete_list->list[i]->startcluster);
   		fnDeleteFileLabel(delete_list->list[i]);	
        
    }
    
    int xx=0;
	for(xx=0;xx<delete_list->num;xx++)
	free(delete_list->list[xx]);
	free(delete_list->list);
	free(delete_list);
  
}



void erase(FILE_t* fp)
{
    
  
  fnFreeFile(fp->startcluster);
  fnDeleteFileLabel(fp);
   
}

void searchFILE(char* string)
{
   if(string[0]=='\0')
   {
        printf("\nPlease enter a valid file name\n");
        return;
   }
   
   BYTE num=0;
   PATH_t search_path;
   strcpy(search_path.path[0],"ROOT");
   search_path.level=0;
   fnSearchFile(0,string,0,&num,&search_path);
   printf("\n\n\"%d\" files found matching \"%s\"\n",num,string);
   
}
  
void printDIRlist(FILELIST_t *filelist1)
{
    int i=0;

    if(current_dir!=0&&filelist1->num==2||current_dir==0&&filelist1->num==0)
    {
        printf("\nDirectory is empty\n\n");
    }
    else
    { 
    	printf("\nS.No.\t\t\t\tName\t\t\t\t\t\tType\t\tSize\n\n");
	    for(i=0;i<filelist1->num;i++)
	    {
	 		if((current_dir!=0)&&(i==0||i==1))
	 		continue;
	 		int type;
	 		char filetype[5];
	 		type=filelist1->list[i]->type;
    
	 		if(type==0x10)
    
	 		  strcpy(filetype,"DIR");
    
	        else
         
	            strcpy(filetype,"FILE");
    
	         
	         printf("%d.\t\t%20ls\t\t%15ls",current_dir?i-1:i+1,filelist1->list[i]->filename,filetype);
	         if(filelist1->list[i]->type!=FILE_ATTR_DIRECTORY)
	         {
	             printf("\t\t\t%d KB",(filelist1->list[i]->filesize/1024)+1);
	         }
	         printf("\n");
	    }
    }
}
    
void printpath()
{
    int i=0;
    for(i=0;i<=p1.level;i++)
    {
        printf("%s\\",p1.path[i]);
    }
    printf("\n\n");
}


void lsDIR()
{
    FILELIST_t* listDIR;
    listDIR=fnListDirectory(current_dir);
    printDIRlist(listDIR);

    int xx=0;
	for(xx=0;xx<listDIR->num;xx++)
	free(listDIR->list[xx]);
	free(listDIR->list);
	free(listDIR);

}	   


void changeDIR(char* dir_name)
{
    if(dir_name[0]=='\0')
    {
        printf("\nPlease enter a valid directory name\n");
        return;
    }
    
    FILELIST_t* filelist= fnListDirectory(current_dir);
    int i=0;
    char temp[257];
    char temp1[257];
    strcpy(temp,dir_name);

    for(i=0;i<filelist->num;i++)
    {
        if(current_dir!=0&&i==0)
        continue;
        strcpy(temp1,filelist->list[i]->filename);
        if(!strcmp(temp,temp1))
        break;
    }
    if(i==filelist->num)
    printf("\nDirectory \"%s\" does not exist\n\n",dir_name);
    else if(filelist->list[i]->type!=FILE_ATTR_DIRECTORY)
    printf("\nThis is not a valid Directory name\n\n");

   
    else
    {
    
        p1.level++;
	    strcpy(p1.path[p1.level],filelist->list[i]->filename);
        current_dir=filelist->list[i]->startcluster;
//        filelist=fnListDirectory(current_dir);
    }

    int xx=0;
	for(xx=0;xx<filelist->num;xx++)
	free(filelist->list[xx]);
	free(filelist->list);
	free(filelist);
}
    

void traverseupDIR()
{
      FILELIST_t* filelist= fnListDirectory(current_dir);
      if(current_dir==0)
      {
          printf("\nCannot go up the root directory level\n\n");
      }
      else
      {
      	current_dir=filelist->list[1]->startcluster;
      	strcpy(p1.path[p1.level],'\0');
      	p1.level--;
      }
  
    int xx=0;
	for(xx=0;xx<filelist->num;xx++)
	free(filelist->list[xx]);
	free(filelist->list);
	free(filelist);
}	        

void gotoROOTDIR()
{
    int i=0;
    for(i=p1.level;i>0;i--)
    {
        	strcpy(p1.path[i],'\0');
    }
    p1.level=0;
    current_dir=0;
}

/**************************************************************/


// Check whether the entry is a long file entry
/***********************************************/

int check_LFN(WORD recordoffset)
{
	if ((read_BYTE(recordoffset+11)&0x0F)==FILE_ATTR_LFN_TEXT) 
		return 1;
	else 
		return 0;
}
/*******************************************************/

//check whether long file entries exist for a short file entry
/*****************************************************************/

int check_SFEforLFN(WORD recordoffset,BYTE stringnum)
{
		if ((read_BYTE(recordoffset+11)!=FILE_ATTR_LFN_TEXT) && (read_BYTE(recordoffset)!=FILE_HEADER_BLANK) && (read_BYTE(recordoffset)!=FILE_HEADER_DELETED)&&stringnum) 
		return 1;
	else 
		return 0;
}
/**********************************************************/


//Check if the entry is invalid
/********************************/

int check_INVALID(WORD recordoffset)
{
	if ((read_BYTE(recordoffset)==FILE_HEADER_BLANK)||(read_BYTE(recordoffset)==FILE_HEADER_DELETED))
	   	return 1;
	else 
		return 0;
}
/*******************************************/




//Check if the entry is a short file name
/********************************************/

int check_SFN(WORD recordoffset)
{
	if ((read_BYTE(recordoffset+11)!=FILE_ATTR_LFN_TEXT) && (read_BYTE(recordoffset)!=FILE_HEADER_BLANK) && (read_BYTE(recordoffset)!=FILE_HEADER_DELETED) )
		return 1;
	else 
		return 0;
}
/***********************************************/


//check if it a directory entry
/******************************************/


int check_DIR(WORD recordoffset)
{
	if ((read_BYTE(recordoffset+11))&FILE_ATTR_DIRECTORY) 
		return 1;
	else 
		return 0;
}
/***********************************************/


//Fetch the long file name
/******************************/

BYTE fetch_LFN(WORD recordoffset,BYTE LFNIndex,BYTE *String)
{
	BYTE i;
	BYTE String_offset;
	//charater location in long file name entry
	BYTE char_locate[13]={1,3,5,7,9,0x0E,0x10,0x12,0x14,0x16,0x18,0x1C,0x1E};
	BYTE sub_size;    
  
	String_offset = 0;
	for(i=1;i<LFNIndex;i++)
	{
		String_offset += 13;
	}	
	sub_size=13;	
	for(i=0;i<13;i++)
	{

         //Charaters in long file name are encoded in unicode format. 
		String[String_offset+i] = read_BYTE(recordoffset+char_locate[i]);
		if(String[String_offset+i]==0)
		{
			sub_size=i;
			break;
		}
	}

	for (i=0; i<13; i++)
	 	 if (String[String_offset+i]==0xFF) 
	 	 	String[String_offset+i] = 0x0; // Replace with space
       //exclude '/0'
	return sub_size;
} 
/******************************************/


//Return checksum for short file name
/****************************************/

BYTE fnGetChksum(BYTE *shortname)
{
	BYTE i,j=0;
	BYTE chksum=0;
    	for (i=11; i>0; i--)
        	
    	{
    	    chksum = ((chksum & 1) ? 0x80 : 0) + (chksum >> 1) + shortname[j++];
    	    chksum = chksum&0x000000FF;
    	}
    	
        	
        return chksum;
}
/**********************************************/


//Initialize the file structure with the long file name entries
/*******************************************************************/

void fnFindFile_LongName(DWORD sector_num,WORD item,DWORD up_folder,BYTE *String_buffer,WORD name_size,FILE_t *file)	
{
	WORD recordoffset=item*32;
	file->flag		|= MODE_OPEN;
	file->startcluster 	= read_WORD(recordoffset+0x1A);
	file->currentcluster.value =file->startcluster;
	file->currentcluster.offset = 0;
	file->curp		= 0;
	file->type		= read_BYTE(recordoffset+0x0B);
	file->filesize		= read_DWORD(recordoffset+0x1C);
	memcpy(file->filename,String_buffer,name_size);
	file->filename[name_size]=0;
	file->listp=sector_num*16+item;
	file->up_folder=up_folder;
}
/****************************************************************************/


//Initialize the file structure with the short file name entry
/*******************************************************************/

void fnFindFile_ShortName(DWORD sector_num,BYTE item,DWORD up_folder,FILE_t *file)
{
	BYTE i,j=0;
	BYTE temp;
	WORD recordoffset=item*32;
	file->flag		|= MODE_OPEN;
	file->startcluster 	= read_WORD(recordoffset+0x1A);
	file->currentcluster.value =file->startcluster;
	file->currentcluster.offset = 0;
	file->curp		= 0;
	file->type		= read_BYTE(recordoffset+0x0B);
	file->filesize		= read_DWORD(recordoffset+0x1C);

	for(i=0;i<8;i++)
	{
		temp = read_BYTE(recordoffset+i);
		if(temp!=0x20)
		{
			file->filename[i] = tolower(temp);
		}
		else
		{
			break;
		}
	}
	if(read_BYTE(recordoffset+8)!=0x20)
	{
		file->filename[i]='.';
		i++;
		for(j=0;j<3;j++)
		{
			temp = read_BYTE(recordoffset+8+j);
			if(temp!=0x20)
			{
				file->filename[i+j] = tolower(temp);
			}
		
			else
			{
				file->filename[i+j] = '\0';
				break;
			}
		}
	}
	else
	{
		file->filename[i]='\0';
	}

	file->filename[i+j] = '\0';
	file->listp=sector_num*16+item;
	file->up_folder=up_folder;
	return;

}
/**********************************************************************************/

//Function to find the number of file in the directory
/************************************************************/

DWORD fnDetectDirectory(WORD startcluster)
{
	BYTE item;
	WORD recordoffset;
	DWORD x=0;
	DWORD filenum=0;
	int rootsector_count=0;
	int rootsector_number=(current_fs->bpb.root_entrice*32+current_fs->bpb.byte_per_sector-1)/current_fs->bpb.byte_per_sector;
	currentcluster_t current_cluster;
	current_cluster.value=startcluster;
	current_cluster.offset=0;

	while ((startcluster!=0&&current_cluster.value!= 0xFFFF)||(startcluster==0&&rootsector_count<rootsector_number)) // Do while not end of cluster chain
	{
		if(startcluster!=0)
		{    // Read Sector
			current_cluster = fnFAT16_SectorReader(current_cluster, x++);
		}
		else
		{
		    read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+rootsector_count,1);
		}
    
		if ((startcluster!=0&&current_cluster.value!= 0xFFFF)||(startcluster==0&&rootsector_count<rootsector_number))
		{
			for (item=0; item<=15;item++)
			{
			  //  if(rootsector_count==0&&startcluster==0&&item==0)
			   // continue;
			  //s  else 
			    if(item==0&&filenum==0&&startcluster==0)
			    continue;
		 		recordoffset = (32*item);
 		 		if ( check_SFN(recordoffset) )
		 		{
 	   	      			filenum++; //File / Dir Count
 	   	      	}
	   	      
			}// end of for
			if(startcluster==0)
			{
			    rootsector_count++;
			}
		}
	}
	return filenum;
} 

/**************************************************************************************/


//Function to initializse the file list structure with the files available in the directory
/*******************************************************************************************/


FILELIST_t* fnListDirectory(WORD startcluster)
{
	int rootsector_count=0;
	int rootsector_number=(current_fs->bpb.root_entrice*32+current_fs->bpb.byte_per_sector-1)/current_fs->bpb.byte_per_sector;

    BYTE i,item,index;
	WORD recordoffset;
	BYTE LFNIndex=0;
	DWORD x=0;
	currentcluster_t current_cluster;

	BYTE stringnum=0,next_num=0;
	BYTE chksum;
	DWORD filenumber=0;
	BYTE String_buffer[20*13];
	BYTE short_name[11];
	WORD name_size=0;

	current_cluster.value=startcluster;
	current_cluster.offset=0;

   FILELIST_t *filelist1=NULL;

       //get numbers of files in current directory
	filenumber = fnDetectDirectory(startcluster);
	filelist1=(FILELIST_t *)malloc(sizeof(FILELIST_t));
	filelist1->list=(FILE_t **)malloc(sizeof(FILE_t *)*(filenumber));
	filelist1->num=filenumber;

	if(filenumber==0)
	{
	
		return NULL;
	}

	filenumber=0;

  
	while ((startcluster!=0&&current_cluster.value!= 0xFFFF)||(startcluster==0&&rootsector_count<rootsector_number) ) // Do while not end of cluster chain
	{
		if(startcluster!=0)
		{    // Read Sector
			current_cluster = fnFAT16_SectorReader(current_cluster, x++);
		}
		else
		{
		    read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+rootsector_count,1);
			x++;
		}

		if ((startcluster!=0&&current_cluster.value!= 0xFFFF)||(startcluster==0&&rootsector_count<rootsector_number) )
		{
			LFNIndex=0;
			for (item=0; item<=15;item++)
			{
		 	//	if(rootsector_count==0&&startcluster==0&&item==0)
			//    continue;
			//    else 
			    if(item==0&&filenumber==0&&startcluster==0)
			    continue;
		    
			    recordoffset = (32*item);
				//check entry type
 				if ( check_INVALID(recordoffset) ) 	
 				{
                                   //invalid entry
		 			stringnum = 0;
		 			name_size = 0;
		 			next_num =0 ;
		 			continue;
		 		} 
				// Long File Name Text Found
				else if ( check_LFN(recordoffset) )
				{
					// if file name entry
					if(stringnum==0)
					{	
                                     //check last entry by checking bit-7, first byte in file name entry
						if((read_BYTE(recordoffset)&0x40)!=0)
						{
							LFNIndex  =read_BYTE(recordoffset)&0x1F;
							stringnum = LFNIndex;
							next_num  = stringnum;
							chksum	  = read_BYTE(recordoffset+0x0D);
						}
						else
						{
                                                 // do nothing if bit-7 is not '1'.
							continue;
						}
					}
					else
					{      
					       // check file name serial number and check code, correct-get file name charaters, error-reset with 0
						if(((read_BYTE(recordoffset)&0x1F)==next_num)&&(read_BYTE(recordoffset+0x0D)==chksum))
						{
							LFNIndex =(read_BYTE(recordoffset)&0x1F);
						}
						else
						{
							stringnum = 0;
		 					name_size = 0;
		 					next_num =0 ;
		 					continue;
		 				}
		 			}
					name_size += fetch_LFN(recordoffset,LFNIndex,String_buffer);
					next_num--;
				} 
		 		// Normal Entry and Long text exists 
		 		else if ( check_SFEforLFN(recordoffset,stringnum) )
		 		{
		 			filelist1->list[filenumber]=(FILE_t*)malloc(sizeof(FILE_t));
		 			read_SectorData(recordoffset,short_name,11);
					// check file name serial number and check code, correct-get long file name charaters, error-get short file name
		 			if((next_num!=0)||(chksum!=fnGetChksum(short_name)))
		 				fnFindFile_ShortName(x-1,item,startcluster,filelist1->list[filenumber]);
		 			else
		 				fnFindFile_LongName(x-1,item,startcluster,String_buffer,name_size,filelist1->list[filenumber]);
		 			filenumber++;
		 			stringnum = 0;
		 			name_size = 0;
		 			next_num =0 ;		
	   	      					  
		 		}
	 
		 		// Normal Entry, only 8.3 Text		 
		 		else if ( check_SFN(recordoffset) )
		 		{
		 			filelist1->list[filenumber]=(FILE_t*)malloc(sizeof(FILE_t));
		 			fnFindFile_ShortName(x-1,item,startcluster,filelist1->list[filenumber]);
       		  		//printf("\n\nfile=\n\n%x",&(filelist1->list[filenumber]->filename));
		 				filenumber++;
		 			stringnum = 0;
		 			name_size = 0;
		 			next_num =0 ; 
		 		}
			}// end of for
		if(startcluster==0)
		{
		    rootsector_count++;
		}
		}
	
	}

	return filelist1;
}



FILE_t *fnFindFile(WORD startcluster,BYTE *filename,BYTE mode)
{
	BYTE i,item,index;
	WORD recordoffset;
	BYTE LFNIndex=0;
	DWORD x=0;
	currentcluster_t current_cluster;

	BYTE stringnum=0,next_num=0;
	BYTE chksum;
	DWORD filenumber=0;
	BYTE String_buffer[20*13];
	BYTE short_name[11];
	WORD name_size=0;
	FILE_t *fp;


	current_cluster.value = startcluster;
	current_cluster.offset = 0;

	fp = (FILE_t*)malloc(sizeof(FILE_t));
	fp->flag=0;  
	//
	while (current_cluster.value!= 0xFFFF) // Do while not end of cluster chain
	{
		// Read Sector
		current_cluster = fnFAT16_SectorReader(current_cluster, x++);

		if (current_cluster.value!=0xFFFF)
		{
			LFNIndex=0;
			for (item=0; item<=15;item++)
			{
		 		recordoffset = (32*item);
 					//check entry type
 				if ( check_INVALID(recordoffset) ) 	
 				{
                               // check file name, reset with 0 if invalid
		 			stringnum = 0;
		 			name_size = 0;
		 			next_num =0 ;
		 			continue;
		 		} 
				// Long File Name Text Found
				else if ( check_LFN(recordoffset) )
				{
					//if long file name entry
					if(stringnum==0)
					{
						 //check last entry by checking bit-7, first byte in file name entry
						if((read_BYTE(recordoffset)&0x40)!=0)
						{
							LFNIndex  =read_BYTE(recordoffset)&0x1F;
							stringnum = LFNIndex;
							next_num  = stringnum;
							chksum	  = read_BYTE(recordoffset+0x0D);
						}
						else
						{
							continue;
						}
					}
					else
					{
						if(((read_BYTE(recordoffset)&0x1F)==next_num)&&(read_BYTE(recordoffset+0x0D)==chksum))
						{
							LFNIndex =(read_BYTE(recordoffset)&0x1F);
						}
						else
						{
							stringnum = 0;
		 					name_size = 0;
		 					next_num =0 ;
		 					continue;
		 				}
		 			}
					name_size += fetch_LFN(recordoffset,LFNIndex,String_buffer);
					next_num--;
				} 
		 		// Normal Entry and Long text exists 
		 		else if ( check_SFEforLFN(recordoffset,stringnum) )
		 		{
		 			//check search mode and entry type matched or not.
		 			if(((read_BYTE(recordoffset+0x0B)&FILE_ATTR_DIRECTORY)==0&&mode==FIND_FILE_MODE)||
		 			   ((read_BYTE(recordoffset+0x0B)&FILE_ATTR_DIRECTORY)!=0&&mode==FIND_DIR_MODE)||
		 			   (mode==FIND_ALL_MODE))
		 			{
		 				read_SectorData(recordoffset,short_name,11);
		 				if((next_num!=0)||(chksum!=fnGetChksum(short_name)))
		 					fnFindFile_ShortName(x-1,item,startcluster,fp);
		 				else
		 					fnFindFile_LongName(x-1,item,startcluster,String_buffer,name_size,fp);
	 				
		 				filenumber++;
			 			stringnum = 0;
		 				name_size = 0;
		 				next_num =0 ;
		 				i=0;
			 			while(1)
			 			{
			 				if(tolower(filename[i])!=tolower(fp->filename[i]))
		 					{
		 						break;
		 					}
		 					if(filename[i]=='\0')
		 					{
		 						return fp;
		 					}
			 				i++;
			 			}
		 			}
	 	   	      					  
		 		}
	 
		 		// Normal Entry, only 8.3 Text		 
		 		else if ( check_SFN(recordoffset) )
		 		{
		 			if(((read_BYTE(recordoffset+0x0B)&FILE_ATTR_DIRECTORY)==0&&mode==FIND_FILE_MODE)||
		 			   ((read_BYTE(recordoffset+0x0B)&FILE_ATTR_DIRECTORY)!=0&&mode==FIND_DIR_MODE)||
		 			   (mode==FIND_ALL_MODE))
		 			{
		 				fnFindFile_ShortName(x-1,item,startcluster,fp);
       		  				filenumber++;
		 				i=0;
		 				while(1)
		 				{
		 					if(tolower(filename[i])!=tolower(fp->filename[i]))
		 					{
		 						break;
		 					}
			 				if(filename[i]=='\0')
			 				{
			 					return fp;
		 					}
		 					i++;
		 				}
	 			
			 			stringnum = 0;
			 			name_size = 0;
			 			next_num =0 ; 
			 		}
		 		
	 			
		 		}
			}// end of for
		}
	}
	free(fp);
	return fp;
} 


/********************************************************************************************/

DWORD fnReadFile(BYTE *buffer, BYTE size, DWORD count, FILE_t *fp)
{

	DWORD read_num;
	DWORD  offset,sp1,sp2,length;
	DWORD bytepercluster = current_fs->byte_per_cluster;
	DWORD bytepersector = current_fs->bpb.byte_per_sector;
	BYTE  *rbuffer;
	DWORD remain;

	rbuffer=buffers.currentsector.u8data;
	//which sector *fp locates	
	offset=fp->curp/bytepersector;

	//sp1 is starting address of target sector
	sp1=fp->curp-offset*bytepersector;

	read_num=size*count;
	//counting  reading data, cut data if overflow
	if((read_num+fp->curp)>fp->filesize)
	{
		read_num=fp->filesize-fp->curp;
	}
	//length: numbers of Byte will be read next operation
	//if length more than one sector, cut length or do next reading operation
	if(read_num>bytepersector-sp1)
	{
		length=bytepersector-sp1;
	}
	else
	{
		length=read_num;
	}
       //start reading data, follow 3 cases
       //case1-start sector-target data start is not the start of the sector
       //case2-reading data-target data is a whole data sector
       //case3-end sector-target data is not the ead of the sector
   
	//case1-read the first sector
	fp->currentcluster = fnFAT16_SectorReader(fp->currentcluster,offset);
	memcpy(buffer,rbuffer+sp1,length);

	fp->curp=fp->curp+length;
	remain=read_num-length;
	sp2 = length;
	offset = offset +1;
	if(remain==0)
		return read_num;

	//case2
	while(remain>bytepersector)
	{
		fp->currentcluster = fnFAT16_SectorReader(fp->currentcluster,offset);
		memcpy(buffer+sp2,rbuffer,bytepersector);	
		fp->curp = fp->curp+bytepersector;
		//sp1=(fp->curp%bytepercluster)%bytepersector;
		sp2 += bytepersector;
		remain =remain-bytepersector;
		offset = offset+1;
	}

	//case3
	fp->currentcluster = fnFAT16_SectorReader(fp->currentcluster,offset);
	memcpy(buffer+sp2,rbuffer,remain);
	fp->curp=fp->curp+remain;

	return read_num;
}

/*********************************************************************************************/



//Function to logically erase a file
/*****************************************/

void fnFreeFile(WORD startcluster)
{
	WORD cluster_chain;
	WORD cluster_temp;

	if(startcluster==0)
		return;
	cluster_chain=startcluster;
	while (cluster_chain!=0xFFFF)
	{
		cluster_temp=fnFAT16_FindNextCluster(cluster_chain);
		fnFAT16_EditFat(cluster_chain,0x00000000);
		cluster_chain=cluster_temp;
	}
}
/***********************************************/

FILE_t * fnOpenFile(FILE_t* fp,BYTE mode)
{
	WORD cluster_chain=0;
	WORD cluster_temp=0;
	DWORD i;

	// check file properties
	if((fp->type&FILE_ATTR_HIDDEN)||(fp->type&FILE_ATTR_SYSTEM)||(fp->type&FILE_ATTR_SYSHID)
	   ||(fp->type&FILE_ATTR_VOLUME_ID ))
	{
		return 0;
	}
	//can not open read-only file by open mode-writable 
	else if(fp->type&FILE_ATTR_READ_ONLY) 
	{
		if((mode&O_WRONLY)||(mode&O_RDWR))
		{
			return 0;
		}
	}
	else
	{
		//initial operation on open mode
		if((mode&O_TRUNC)&&(mode&O_WRONLY))
		{
			fnFreeFile(fp->startcluster);
			fp->startcluster=0;
			fp->currentcluster.value=0;
			fp->currentcluster.offset=0;
			fp->curp=0;
			fp->filesize = 0;	
		}
		if(mode&O_APPEND)
		{
			if(fp->filesize!=0)
			{
			
				fp->curp = fp->filesize;
				cluster_temp=fp->startcluster;
				i=0;
				while (cluster_temp!=0xFFFF)
				{
					cluster_chain=cluster_temp;
					cluster_temp=fnFAT16_FindNextCluster(cluster_chain);
					i++;
				}
				fp->currentcluster.value = cluster_chain;
				fp->currentcluster.offset = i-1;
			}
		}
	}
	
	return fp;
}

/**************************************************************************/

//Fucntion to write a file from a buffer 
/**************************************************/


DWORD fnWriteFile(BYTE *buffer, BYTE size, DWORD count, FILE_t *fp)
{
	DWORD write_num=size*count;
	DWORD  offset,offset1,sp1,sp2,length;
	DWORD bytepercluster = current_fs->bpb.byte_per_sector*current_fs->bpb.sector_per_cluster;
	WORD bytepersector = current_fs->bpb.byte_per_sector;
	BYTE  *wbuffer;
	DWORD remain_write,remain_place;
	WORD cluster_temp;
	DWORD old_filesize=fp->filesize;

	wbuffer=buffers.currentsector.u8data;
	//get sector number that contain the current file
	offset=fp->curp/bytepersector;
	//get offest of current sector in current clustor
	offset1= offset%current_fs->bpb.sector_per_cluster;

	//modify file size if it overflows
	if(fp->curp+write_num>fp->filesize)
	{
		fp->filesize=fp->curp+write_num;
	}
	//get starting address of writing
	sp1=fp->curp-offset*bytepersector;//(fp->curp%bytepercluster)%bytepersector;

	//get starting address of buffer
	sp2=0;

	//remain_write: left mumber of bytes which not be writtin in buffer 
	remain_write=write_num;

	//remain_place: left space in current cluster
	remain_place=bytepercluster-(fp->curp)%bytepercluster;
	if((fp->curp)%bytepercluster==0&&fp->curp!=0)
	remain_place=0;

		while(1)
		{
		       //read in source sector
			if(fp->curp<=old_filesize)
			{
				cluster_temp=fp->currentcluster.value;
			    fp->currentcluster = fnFAT16_SectorReader(fp->currentcluster,offset);
			}
		
			//length: mumber of bytes in one copy operation
			length=remain_write;
			if(length>bytepersector-sp1)
			{
				length=bytepersector-sp1;
			}
			//create a new cluster if length > main_place or current custer is invalid
			if((length>remain_place)&&(fp->currentcluster.value==0xFFFF))//||(length==bytepersector)&&(fp->curp%bytepercluster==0))	
			{
			
			    
				fp->currentcluster.value = fnFAT16_NextEmptyCluster();

                            //modify the size of file if fail in creating a new cluster, return
				if(fp->currentcluster.value==0xFFFF)
				{
					if(fp->filesize>old_filesize)
					{
						fp->filesize=fp->curp;
					}
					return sp2;
				}
				//FAT_buffer޸Ĵ
				fnFAT16_EditFatChain(cluster_temp,fp->currentcluster.value);
				fnFAT16_EditFatChain(fp->currentcluster.value,0xFFFF);
				remain_place +=bytepercluster;
			}
			memcpy(wbuffer+sp1,buffer+sp2,length);	
			//stop_cycle();
			fp->currentcluster=fnFAT16_WriteSector(fp->currentcluster,offset);
			//enable_cycle();
			offset++;
			offset1++;
			fp->curp = fp->curp+length;
			sp1=0;//(fp->curp%bytepercluster)%bytepersector;
			sp2 += length;
			if(sp2>=write_num)
				break;
			remain_write -=length;
			remain_place -=length;
			if(offset1 == current_fs->bpb.sector_per_cluster)
			{
				offset1 = 0;
				cluster_temp=fp->currentcluster.value;
				fp->currentcluster.value=fnFAT16_FindNextCluster(fp->currentcluster.value);
				fp->currentcluster.offset++;
			}
		
		}
		//refresh FAT
		fnFAT16_UpdateFAT();
		//refresh file directory
		fnUpdateFILE(fp);
		return write_num;
	//}
}

/******************************************************************/

//Remove file units in previous sector
/******************************************/

BYTE fnDeleteFileLabel(FILE_t *fp)
{
	int root_flag=0;
    int rootsector_count=0;
    int label=fp->listp%16;
	DWORD offset=fp->listp/16;
	BYTE label_num1=0;
	currentcluster_t current_cluster={fp->up_folder,0};

	if(current_cluster.value==0)
	{
	    root_flag=1;
	    read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+offset,1);
	}
	
	else
		fnFAT16_SectorReader(current_cluster,offset);
	//insert remove flag
	write_BYTE(label*32,0xE5);
	while(1)
	{	
		// return label_num1 if go to the end of current directory
		if(label==0&&offset==0)
		{
			return label_num1;
		}
		label--;
		//do following stuffs when label reach to previous sector
		//write current sector and read previous sector, keep searching

		if(label<0)
		{
		    if(root_flag==1)
		     	   write_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+offset,1);
		     else
		    	   fnFAT16_WriteSector(current_cluster,offset);
			offset--;
			label=15;
			if(root_flag==1)
				read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+offset,1);
			else
				fnFAT16_SectorReader(current_cluster,offset);
		}
		
		//delete previous label if it is valid file name unit.
		if((read_BYTE(label*32)!=0xE5)&&(read_BYTE(label*32+0x0B)==0x0F))
		{

		    			label_num1++;
			write_BYTE(label*32,0xE5);
		}
		else
		{
			break;
		}
	}
	
	if(root_flag==1)
	{
	    write_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+offset,1) ;
	}
	else
	{
		//write back last modified sector
		fnFAT16_WriteSector(current_cluster,offset);
	}
	return label_num1;
}

/****************************************************************************/


//Find empty labels to store new entry
//*********************************************/


WORD fnFindEmptyLabel(WORD startcluster,BYTE n)
{
	DWORD labe_per_cluster=current_fs->bpb.sector_per_cluster*16;
	WORD label_offset=0;
	WORD  sector_offset=0;
	BYTE  idle_label=0;
	WORD next_cluster;
	currentcluster_t current_cluster={startcluster,0};

	while(1)
	{
		if(label_offset==0&&sector_offset==0)
		{
			if(startcluster==0)
			{
		    	read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+sector_offset,1);
		    	label_offset++;
			}
			else 
			{
			    	current_cluster=fnFAT16_SectorReader(current_cluster,sector_offset);
			}
			sector_offset++;   
		    //label_offset++;
		    continue;
		}
		 
	    if(label_offset%16==0&&label_offset!=0)
		{
			if(startcluster==0)
			{
			   read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+sector_offset,1);
			   sector_offset++;
			   if(sector_offset==32)
			   return -1;
			}
			   
			else
			{
			    //get next secotr
				current_cluster=fnFAT16_SectorReader(current_cluster,sector_offset);
				//create a new cluster for up folder if get no next sector
				if(current_cluster.value==0xFFFF)
				{
					next_cluster=fnFAT16_NextEmptyCluster();
					if(next_cluster==0xFFFF)
					{
						return 0xFFFF;
					}
					fnFAT16_EditFatChain(current_cluster.value,next_cluster);
					fnFAT16_EditFatChain(next_cluster,0xFFFF);
					current_cluster.value=next_cluster;
				}
			
				sector_offset++;
			}
			
		}

		if((read_BYTE(label_offset%16*32)==0xE5)||(read_BYTE(label_offset%16*32)==0x00))
		{
			idle_label++;
		}
		else
		{
			idle_label=0;
		}
		if(idle_label>n)
		{
			break;
		}
		label_offset++;		
	}

	if(startcluster!=0)
		 fnFAT16_UpdateFAT();
	return label_offset;
}

/**************************************************************************************/


//Function to make a file entry
/**********************************************/

BYTE fnWriteFileLabel(FILE_t *fp,file_label_t *buffer,int label,int label_num)
{
	WORD i,j,label_count=0,sector_offset=label/16;
	int label_offset=label%16;
	lfn_label_t *lfn_buffer;
	BYTE chksum;
	BYTE data_buffer[32];
	BYTE name_len=strlen(fp->filename);
	currentcluster_t current_cluster={fp->up_folder,0};

	lfn_buffer=(lfn_label_t *)malloc(sizeof(lfn_label_t));

	if(fp->up_folder==0)
	{
	    read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+sector_offset,1);
	    
	}
	else
	{
	    
		fnFAT16_SectorReader(current_cluster,sector_offset);
	}
	
	write_SectorData(label_offset*32,(BYTE *)buffer,32);

	if(label_num==0)
	{
		if(fp->up_folder==0)
		{
	    //	write_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+sector_offset,1);
	    //	BYTE bufff[512];
		 //   for(i=0;i<512;i++)
		 //   bufff[i]=i;
   		   	write_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+sector_offset,1);
   
		}
		
		else
		{
	    	fnFAT16_WriteSector(current_cluster,sector_offset);
		}
		
		free(lfn_buffer);
		return 1;
	}

	chksum=fnGetChksum(buffer->short_name);

	while(1)
	{
		label_offset--;	
		if(label_offset<0)
		{
			sector_offset--;
			label_offset=15;
			
			if(fp->up_folder==0)
			{
			    write_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+sector_offset+1,1);			    
			    read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+sector_offset,1);
			}
			else
			{
				fnFAT16_WriteSector(current_cluster,sector_offset+1);
				fnFAT16_SectorReader(current_cluster,sector_offset);
			}
		}
	
		i=13*label_count;
		for(j=0;j<10;j=j+2)
		{
			
			if(i==name_len)
			{
				lfn_buffer->name1[j]=0x00;
				lfn_buffer->name1[j+1]=0x00;
				i++;
			}
			else if(i>name_len)
			{
				lfn_buffer->name1[j]=0xFF;
				lfn_buffer->name1[j+1]=0xFF;
			}
			else
			{
				lfn_buffer->name1[j]=fp->filename[i++];
				lfn_buffer->name1[j+1]=0x00;
			}
		}
		for(j=0;j<12;j=j+2)
		{
			if(i==name_len)
			{
				lfn_buffer->name2[j]=0x00;
				lfn_buffer->name2[j+1]=0x00;
				i++;
			}
			else if(i>name_len)
			{
				lfn_buffer->name2[j]=0xFF;
				lfn_buffer->name2[j+1]=0xFF;
			}
			else
			{
				lfn_buffer->name2[j]=fp->filename[i++];
				lfn_buffer->name2[j+1]=0x00;
			}
		}
		for(j=0;j<4;j=j+2)
		{
			if(i==name_len)
			{
				lfn_buffer->name3[j]=0x00;
				lfn_buffer->name3[j+1]=0x00;
				i++;
			}
			else if(i>name_len)
			{
				lfn_buffer->name3[j]=0xFF;
				lfn_buffer->name3[j+1]=0xFF;
			}
			else
			{
				lfn_buffer->name3[j]=fp->filename[i++];
				lfn_buffer->name3[j+1]=0x00;
			}
		}

		if(label_count==label_num-1)
		{
			lfn_buffer->num=(label_count+1)|0x40;
		}
		else
		{
			lfn_buffer->num=(label_count+1);
		}
		lfn_buffer->flag=0x0F;
		lfn_buffer->reserve=0;
		lfn_buffer->chksum=chksum;
		lfn_buffer->startcluster[0]=0;
		lfn_buffer->startcluster[1]=0;
	
		data_buffer[0]=lfn_buffer->num;
		memcpy(data_buffer+1,lfn_buffer->name1,13);
		memcpy(data_buffer+14,lfn_buffer->name2,18);
	
		write_SectorData(label_offset*32,data_buffer,32);
		if(label_count==label_num-1)
		{
			break;
		}
		label_count++;
	}
	
	if(fp->up_folder==0)
	
		    write_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+sector_offset,1);			    
	else
			fnFAT16_WriteSector(current_cluster,sector_offset);
	
	free(lfn_buffer);
	return 1;
}

/*********************************************************************************/


//Get the number of files having same short name
/****************************************************/

BYTE fnGetShortNum(FILE_t *fp,BYTE *short_name)
{
	BYTE item;
	WORD recordoffset=0;
	DWORD x=0;
	BYTE name[11];
	BYTE num=1,temp;;
	BYTE refind=0;
	currentcluster_t current_cluster={fp->up_folder,0};
	
	while (current_cluster.value!= 0xFFFF) // Do while not end of cluster chain
	{
		if(current_cluster.value==0)
		{
		    read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+x,1);
		    x++;
		    if(x==32)
		    break;
		}
	    // Read Sector
		else
	    current_cluster = fnFAT16_SectorReader(current_cluster, x++);

		if (current_cluster.value!=0xFFFF)
		{
			for (item=0; item<=15;item++)
			{
				recordoffset = (32*item);
				if(((x*16+item)!=fp->listp)&&(read_BYTE(recordoffset)!=0xE5))
				{
		 			read_SectorData(recordoffset,name,11);
		 			if(strncmp(short_name+8,name+8,3)!=0)
		 				continue;
		 			if((strncmp(short_name,name,4)==0)&&(name[4]=='~'))
		 			{
		 				temp=num%100;
		 				if((name[5]==(num/100+'0'))&&(name[6]==(temp/10+'0'))&&(name[7]==(temp%10+'0')))
		 				{
		 					num++;
		 					refind=1;
		 					break;
		 				}
		 			}
		 		}
		 	}
		 }
		 if(refind==1)
		 {
		 	refind=0;
		 	current_cluster.value=fp->up_folder;
		 	current_cluster.offset=0;
		 	x=0;
		 }
	}
	 				 		
	return num;
}

/**********************************************************************************************/



BYTE fnUpdateFILE(FILE_t *fp)
{
	int i,j;
	file_label_t *buffer;
	BYTE short_name[11]="           ";
	BYTE ext[256]="   ";
	BYTE name[256];
	int label_num1,label_num2,label,temp;
	DWORD offset;
	BYTE type=0;
	//type = 0 - normal short
	//type =1 - normal long
	//type=2 - short, caps
	//type=3 - short, blank

	currentcluster_t currentcluster={fp->up_folder,0};

	buffer=(file_label_t *)malloc(sizeof(file_label_t));
	
	if(fp->up_folder==0)
	{
	    DWORD sector_offset=fp->listp/16;
	    read_BufferSector(buffers.currentsector.u8data,current_fs->root_begin_lba+sector_offset,1);
	}
	
	else
	{
		fnFAT16_SectorReader(currentcluster,fp->listp/16);
	}
	
	
	read_SectorData((fp->listp%16)*32,(BYTE *)buffer,32);

	//remove original file directory
	label_num1=fnDeleteFileLabel(fp);

	//get file name and extended file name
	for(i=strlen(fp->filename);i>0;i--)
	{
		if(fp->filename[i]=='.')
		{
			memcpy(ext,fp->filename+i+1,strlen(fp->filename)-i);
			memcpy(name,fp->filename,i);
			name[i]='\0';
			break;
		}
	}
	if(i==0)
	{
		memcpy(name,fp->filename,strlen(fp->filename)+1);
	}

	//get file type
	if((strlen(name)<=8)&&(strlen(ext)<=3))
	{
		type=0;
		label_num2=0;
		for(i=0;name[i]!='\0';i++)
		{
			if((name[i]<='Z'&&name[i]>='A'))
			{
				type=2;
				label_num2=1;
				break;
			}
			if(name[i]==' '||name[i]=='.')
			{	
				type=3;
				label_num2=1;
				break;
			}
		}
		for(i=0;ext[i]!='\0';i++)
		{
			if((ext[i]<='Z'&&ext[i]>='A'))
			{
				type=2;
				label_num2=1;
				break;
			}
		}
	}
	else
	{
		label_num2=(strlen(fp->filename)-1)/13+1;
		type=1;
	}

	//get file starting
	if(label_num2>label_num1)
	{
		label=fnFindEmptyLabel(fp->up_folder,label_num2);
		fp->listp=label;
	}
	else
	{
		label=fp->listp;
	}
	//get short file name with 'type'
	switch(type)
	{
		case 0:
		case 2:
		{
			memcpy(short_name,name,strlen(name));
			memcpy(short_name+8,ext,strlen(ext));
			for(i=0;i<11;i++)
			{
				if(short_name[i]!=' ')
				{
					if(short_name[i]<='z'&&short_name[i]>='a')
						short_name[i]=short_name[i]-0x20;
				}
			}
			break;
		}
		case 1:
		case 3:
		{
			if(strlen(ext)<=3)
			{
				memcpy(short_name+8,ext,strlen(ext));
			}
			else
			{
				memcpy(short_name+8,ext,3);
			}
			for(i=0,j=0;i<strlen(name);i++)
			{
				if(name[i]==' '||name[i]=='.')
					continue;
				short_name[j]=toupper(name[i]);
				j++;
				if(j==4)
					break;
			}
			for(i=0,j=8;i<strlen(ext);i++)
			{
				if(ext[i]==' '||ext[i]=='.')
					continue;
				short_name[j]=toupper(ext[i]);
				j++;
				if(j==11)
					break;
			}
		
			temp=fnGetShortNum(fp,short_name);
			short_name[4]='~';

			short_name[5]=temp/100+'0';
			temp=temp%100;
			short_name[6]=temp/10+'0';
			short_name[7]=temp%10+'0';
		
			for(i=0;i<11;i++)
			{
				if(short_name[i]!=' ')
				{
					if(short_name[i]<='z'&&short_name[i]>='a')
						short_name[i]=short_name[i]-0x20;
				}
			}
			break;
		}
	}

	//handle '.' &'..' directories
	if(strcmp(fp->filename,".")==0||strcmp(fp->filename,"..")==0)
	{
		for(i=0;i<11;i++)
			short_name[i]=0x20;
		memcpy(short_name,fp->filename,strlen(fp->filename)+1);
		label_num2=0;
		label=label-1;
	}

	memcpy(buffer->short_name,short_name,11);
	buffer->type = fp->type;

	buffer->filesize[0]=fp->filesize&0x000000FF;
	buffer->filesize[1]=(fp->filesize&0x0000FF00)>>8;
	buffer->filesize[2]=(fp->filesize&0x00FF0000)>>16;
	buffer->filesize[3]=(fp->filesize&0xFF000000)>>24;

	buffer->first_cluster[0]=fp->startcluster&0x00FF;
	buffer->first_cluster[1]=fp->startcluster>>8;
	buffer->create_time_10ms = 0;
	buffer->create_time[0] = 0;
	buffer->create_time[1] = 0;
	buffer->create_date[0] = 0;
	buffer->create_date[1] = 0;
	buffer->last_visit_date[0] = 0;
	buffer->last_visit_date[1] = 0;
	buffer->last_edit_time[0] = 0;
	buffer->last_edit_time[1] = 0;
	buffer->last_edit_date[0] =0;
	buffer->last_edit_date[0] =0;
	//write back undated file label to HD driver
	fnWriteFileLabel(fp,buffer,label,label_num2);

	free(buffer);
	return 1;
}


FILE_t *fnCreateFile(WORD startcluster,BYTE *name)
{
	FILE_t *fp;
	fp=(FILE_t *)malloc(sizeof(FILE_t));
	fp->listp=fnFindEmptyLabel(startcluster,0);
	if(fp->listp==0xFFFF)
	{
		return NULL;
	}
	fp->flag=MODE_OPEN;
	fp->startcluster=fnFAT16_NextEmptyCluster();
	fnFAT16_EditFat(fp->startcluster,0xFFFF);
	fp->curp =0;
	memcpy(fp->filename,name,strlen(name)+1);
	fp->type = 0x20;
	fp->filesize =0;	
	fp->up_folder = startcluster;
	fp->currentcluster.value=fp->startcluster;
	fp->currentcluster.offset=0;

	fnUpdateFILE(fp);

	return fp;
}


void clearcluster(WORD cluster_number)
{
    int i=0;
    BYTE* buffer;
    buffer=(BYTE*)(malloc(current_fs->bpb.byte_per_sector));
    for(i=0;i<current_fs->bpb.byte_per_sector;i++)
    {
        buffer[i]=0;
    }
    
    DWORD sector_start=fnFAT16_LBAofCluster(cluster_number);
    
       
    for(i=0;i<current_fs->bpb.sector_per_cluster;i++)
    {
        write_BufferSector(buffer,sector_start+i,1);
    }
        
}


BYTE fnCreateDir(WORD startcluster,BYTE *name)
{
	FILE_t *fp;
	WORD current_cluster;

	fp=(FILE_t *)malloc(sizeof(FILE_t));
	fp->listp=fnFindEmptyLabel(startcluster,0);
	if(fp->listp==0xFFFF)
	{
		return 0;
	}
	fp->flag=0;
	fp->startcluster=fnFAT16_NextEmptyCluster();
	clearcluster(fp->startcluster);
	fnFAT16_EditFat(fp->startcluster,0xFFFF);
	
	current_cluster= fp->startcluster;
	fp->curp =0;
	memcpy(fp->filename,name,strlen(name)+1);
	fp->type = FILE_ATTR_DIRECTORY;
	fp->filesize =0;	
	fp->up_folder = startcluster;

	fnUpdateFILE(fp);
	
	//Initialize dot and dot_dot entries
	
	
	DWORD parent_start_lba;
	
	if(fp->up_folder!=0)
          parent_start_lba=fnFAT16_LBAofCluster(fp->up_folder);
    else
          parent_start_lba=current_fs->root_begin_lba;
        
    DWORD sector_offset=fp->listp/16;
    DWORD offset=(fp->listp%16)*32;
    
    read_BufferSector(buffers.currentsector.u8data,parent_start_lba+sector_offset,1);
    
    
    BYTE* buff_dot;
    buff_dot=(BYTE*)(malloc(32));
    
    read_SectorData(offset,buff_dot,32);
    
    buff_dot[0]='.';
    
    int i;
    for(i=1;i<11;i++) 
    {
        buff_dot[i]=' ';
    }
    
    BYTE* buff_dot_dot;
    buff_dot_dot=(BYTE*)(malloc(32));
    
    
    if(fp->up_folder!=0)
    {
        read_BufferSector(buffers.currentsector.u8data,parent_start_lba,1);
        read_SectorData(0,buff_dot_dot,32);
        
    }
    else
    {
        for(i=2;i<32;i++)
        buff_dot_dot[i]=0;
        
    }
    buff_dot_dot[11]=0x10;
    buff_dot_dot[0]='.';
    buff_dot_dot[1]='.';
    
    
    DWORD current_dir_lba=fnFAT16_LBAofCluster(fp->startcluster);
    
    read_BufferSector(buffers.currentsector.u8data,current_dir_lba,1);
    write_SectorData(0, buff_dot, 32);
	write_SectorData(32,buff_dot_dot, 32);
	write_BufferSector(buffers.currentsector.u8data, current_dir_lba, 1);
    
	free(buff_dot);
	free(buff_dot_dot);   
	free(fp);
	return 1;
}


void fnSearchFile(WORD startcluster,BYTE * name,BYTE level,BYTE *num,PATH_t* p)
{
	DWORD i=0,j=0;
	FILELIST_t *filelist;

	if(level>5)
	{
		//do five level search here
		return;
	}

	//get files and directory infor. in current direcotry
	filelist=fnListDirectory(startcluster);
	while(i<filelist->num)
	{
		//do nothing with '.' & '..' direcotries
		if((strcmp(filelist->list[i]->filename,".")==0)||(strcmp(filelist->list[i]->filename,"..")==0))
		{
			i++;
			continue;
		}
		//do recursion to directory here
		if(filelist->list[i]->type&FILE_ATTR_DIRECTORY)
		{
		    p->level++;
		    strcpy(p->path[p->level],filelist->list[i]->filename);
			fnSearchFile(filelist->list[i]->startcluster,name,level,num,p);
		}
		else
		{
			j=0;
			while(1)
		 	{
				//compare every character of file name, break is error or reach to end of file name
		 		if(tolower(filelist->list[i]->filename[j])!=tolower(name[j]))
		 		{
		 			break;
		 		}
		 		if(filelist->list[i]->filename[j]=='\0')
		 		{
		 			break;
		 		}
		 		j++;
		 	}
			//list file names if matched
			if((filelist->list[i]->filename[j]=='\0')&&(name[j]=='\0'))
			{
				if(*num>=255)
				{
					break;
				}
			
				if(*num==0)
					printf("\nFile \"%s\" found at the following paths: \n", name);
				
				printf("\n%d.   ",*num+1);
				 
				int ii=0;
    			for(ii=0;ii<=p->level;ii++)
    			{
        				printf("%s\\",p->path[ii]);
    			}
    		
    			printf("%s",filelist->list[i]->filename);
				*num=(*num)+1;
			}
			else
			{
				i++;
				continue;
			}

		}
		i++;
	}

	strcpy(p->path[p->level],'\0');
    p->level--;
	for(i=0;i<filelist->num;i++)
	{
		free(filelist->list[i]);
	}
	free(filelist->list);
	free(filelist);
	return;
}

currentcluster_t fnGetCurrentCluster(DWORD curp,WORD startcluster)
{
	DWORD i;
	WORD cluster_chain=startcluster;
	DWORD offset=curp/(current_fs->bpb.byte_per_sector*current_fs->bpb.sector_per_cluster);
	currentcluster_t cluster;

	for(i=0;i<offset;i++)
	{
		cluster_chain=fnFAT16_FindNextCluster(cluster_chain);
		if(cluster_chain==0xFFFF)
			break;
	}
	cluster.value = cluster_chain;
	cluster.offset = i;
	return cluster;
}
